**free
ctl-opt nomain ;

//----------------------------------------------------------------------
//
// Gaia Mini Systmes 2016
// Outils da conversion des dates/heures/horodatage
//   entre RPG <-> Axis
//
// Version 1.0.0
// TODO : amliorer la gestion des erreurs
//
//----------------------------------------------------------------------


// Dclarations des prototypes des procdures exportes du module
// -----------------------------------------------------------------------------
// pour inclusion des dfinitions AXIS
/define AxisTools_AxisDefinitions
/include AXISTOOLSP ;


// Prototypes internes : C standard library (time.h)
// -----------------------------------------------------------------------------

// typedef
dcl-s size_t int(10) template ;

// strftime : Convert Date/Time to String
// size_t strftime(char *s, size_t maxsize, const char *format,
//                   const struct tm *timeptr);
dcl-pr strftime like(size_t) extproc(*cwiden : *dclcase) ;
  s        char(255)      options(*varsize) ;
  maxsize  like(size_t)                    value ;
  format   pointer        options(*string) value ;
  tm       likeds(xsd_tm)                  const ;
end-pr;

// strptime : Convert String to Date/Time
// char *strptime(const char *buf, const char *format, struct tm *tm);
dcl-pr strptime pointer extproc(*cwiden : *dclcase) ;
  charDate   pointer        options(*string : *trim) value ;
  format     pointer        options(*string : *trim) value ;
  tm         likeds(xsd_tm) ;
end-pr;

// Procdures exportes du module
// -----------------------------------------------------------------------------


// dateToAxis
// ===================================

dcl-proc dateToAxis export ;
  dcl-pi *n ind ;
    p_date    date const ;
    p_xsddate likeds(xsd_date) ;
  end-pi;

  // Traitement
  clear p_xsddate ;
  monitor ;
    if strptime( %char(p_date:*iso) :
                 '%G-%m-%d' :
                 p_xsddate.value) = *null ;
      clear p_xsddate ;
      return *off ;
    endif ;
  on-error ;
    clear p_xsddate ;
    return *off ;
  endmon ;
  return *on ;

end-proc;


// axisToDate
// ===================================

dcl-proc axisToDate export ;
  dcl-pi *n ind ;
    p_xsddate likeds(xsd_date) const ;
    p_date    date ;
  end-pi;

  // Variables locales
  dcl-ds l_tm    likeds(xsd_tm) ;
  dcl-s  l_dateA char(11) inz;

  // Traitement
  clear p_date ;
  if p_xsddate.isNil = *on ;
    return *off ;
  endif ;
  monitor ;
    l_tm = p_xsddate.value ;
    strftime(l_dateA : %len(l_dateA) : '%G-%m-%d' : l_tm);
    p_date = %date( %subst( l_dateA : 1 : 10 ) : *iso ) ;
  on-error ;
    clear p_date ;
    return *off ;
  endmon ;
  return *on ;

end-proc;


// timeToAxis
// ===================================

dcl-proc timeToAxis export ;
  dcl-pi *n ind ;
    p_time    time const ;
    p_xsdtime likeds(xsd_time) ;
  end-pi;

  // Traitement
  clear p_xsdtime ;
  monitor ;
    if strptime( %char(p_time:*iso) :
                 '%H.%M.%S' :
                 p_xsdtime.value) = *null ;
      clear p_xsdtime ;
      return *off ;
    endif ;
  on-error ;
    clear p_xsdtime ;
    return *off ;
  endmon ;
  return *on ;

end-proc;


// axisToTime
// ===================================

dcl-proc axisToTime export ;
  dcl-pi *n ind ;
    p_xsdtime likeds(xsd_time) const ;
    p_time    time ;
  end-pi;

  // Variables locales
  dcl-ds l_tm    likeds(xsd_tm) ;
  dcl-s  l_timeA char(9) inz;

  // Traitement
  clear p_time ;
  if p_xsdtime.isNil = *on ;
    return *off ;
  endif ;
  monitor ;
    l_tm = p_xsdtime.value ;
    strftime(l_timeA : %len(l_timeA) : '%H.%M.%S' : l_tm);
    p_time = %time( %subst( l_timeA : 1 : 8 ) : *iso ) ;
  on-error ;
    return *off ;
  endmon ;
  return *on ;

end-proc;


// datetimeToAxis
// ===================================

dcl-proc datetimeToAxis export ;
  dcl-pi *n ind ;
    p_datetime    timestamp const ;
    p_xsddatetime likeds(xsd_datetime) ;
  end-pi;

  // Traitement
  clear p_xsddatetime ;
  monitor ;
    // YYYY-mm-dd-HH.MM.SS => 19 caractres
    if strptime( %subst( %char(p_datetime) : 1 : 19 ) :
                 '%G-%m-%d-%H.%M.%S' :
                 p_xsddatetime.value) = *null ;
      clear p_xsddatetime ;
      return *off ;
    endif ;
  on-error ;
    clear p_xsddatetime ;
    return *off ;
  endmon ;
  return *on ;

end-proc;


// axisToDateTime
// ===================================

dcl-proc axisToDateTime export ;
  dcl-pi *n ind ;
    p_xsddatetime likeds(xsd_dateTime) const ;
    p_datetime    timestamp ;
  end-pi;

  // Variables locales
  dcl-ds l_tm         likeds(xsd_tm) ;
  dcl-s  l_timeStampA char(20) inz;

  // Traitement
  clear p_datetime ;
  if p_xsddatetime.isNil = *on ;
    return *off ;
  endif ;
  monitor ;
    l_tm = p_xsddatetime.value ;
    strftime(l_timeStampA : %len(l_timeStampA) : '%G-%m-%d-%H.%M.%S' : l_tm);
    p_datetime = %timestamp( %subst( l_timeStampA : 1 : 19 ) : *iso : 0 ) ;
  on-error ;
    return *off ;
  endmon ;
  return *on ;

end-proc; 