      /if defined( AxisTools )
      /eof
      /endif
      /define AxisTools


      //----------------------------------------------------------------------
      //
      // Gaia Mini Systmes 2016
      // Outils da conversion des dates/heures/horodatage
      //   entre RPG <-> Axis
      //
      //----------------------------------------------------------------------


      /if defined( AxisTools_AxisDefinitions )

       // Dfinition des types AXIS pour compilation du module utilitaire
       //----------------------------------------------------------------------

       // All time/date types
       // -------------------
       dcl-ds xsd_tm align qualified template ;
         sec   int(10) ;    // seconds after the minute (0-61)
         min   int(10) ;    // minutes after the hour (0-59)
         hour  int(10) ;    // hours since midnight (0-23)
         mday  int(10) ;    // day of the month (1-31)
         mon   int(10) ;    // months since January (0-11)
         year  int(10) ;    // years since 1900
         wday  int(10) ;    // days since Sunday (0-6)
         yday  int(10) ;    // days since January 1 (0-365)
         isdst int(10) ;    // Daylight Saving Time flag
       end-ds ;

       // dateTime
       dcl-ds xsd_dateTime qualified template ;
         isNil ind ;
         value likeds(xsd_tm) ;
       end-ds;
       // date
       dcl-ds xsd_date likeds(xsd_dateTime) template ;
       // time
       dcl-ds xsd_time likeds(xsd_dateTime) template ;

      /endif


       // Conversion xsd_date vers Date
       //----------------------------------------------------------------------
       //
       // @return : *on  Conversion OK, p_date aliment
       //           *off Erreur de conversion
       //
       // @param p_xsddate : date en entre au format Axis xsd_date
       // @param p_date    : renseign si valeur de retour *on
       //                    contient la date au format RPG
       //----------------------------------------------------------------------
       dcl-pr axisToDate ind;
         p_xsddate likeds(xsd_date) const ;
         p_date date ;
       end-pr ;


       // Conversion xsd_time vers Time
       //----------------------------------------------------------------------
       //
       // @return : *on  Conversion OK, p_time aliment
       //           *off Erreur de conversion
       //
       // @param p_xsdtime : Heure en entre au format Axis xsd_time
       // @param p_time    : renseign si valeur de retour *on
       //                    contient l'heure au format RPG
       //----------------------------------------------------------------------
       dcl-pr axisToTime ind;
         p_xsdtime likeds(xsd_time) const ;
         p_time time ;
       end-pr ;


       // Conversion xsd_dateTime vers Timestamp
       //----------------------------------------------------------------------
       //
       // @return : *on  Conversion OK, p_datetime aliment
       //           *off Erreur de conversion
       //
       // @param p_xsddatetime : horodatage en entre au format Axis xsd_datetime
       // @param p_datetime    : renseigne si valeur de retour *on
       //                        contient l'horodatage au format RPG
       //----------------------------------------------------------------------
       dcl-pr axisToDateTime ind;
         p_xsddatetime likeds(xsd_datetime) const ;
         p_datetime timestamp ;
       end-pr ;


       // Conversion Timestamp vers xsd_dateTime
       //----------------------------------------------------------------------
       //
       // @return : *on  Conversion OK, p_xsddatetime aliment
       //           *off Erreur de conversion
       //
       // @param p_datetime : horodatage en entre
       // @param p_xsddatetime : renseign si valeur de retour *on
       //                        contient l'horodatage au format Axis xsd_dateTime
       //----------------------------------------------------------------------
       dcl-pr datetimeToAxis ind ;
         p_datetime timestamp const ;
         p_xsddatetime likeds(xsd_datetime) ;
       end-pr ;


       // Conversion Date vers xsd_date
       //----------------------------------------------------------------------
       //
       // @return : *on  Conversion OK, p_xsddate aliment
       //           *off Erreur de conversion
       //
       // @param p_date : date en entre
       // @param p_xsddate : renseign si valeur de retour *on
       //                    contient la date au format Axis xsd_date
       //----------------------------------------------------------------------
       dcl-pr dateToAxis ind ;
           p_date date const ;
           p_xsddate likeds(xsd_date) ;
       end-pr ;


       // Conversion Time vers xsd_time
       //----------------------------------------------------------------------
       //
       // @return : *on  Conversion OK, p_xsdtime aliment
       //           *off Erreur de conversion
       //
       // @param p_time : heure en entre
       // @param p_xsdtime : renseign si valeur de retour *on
       //                    contient l'heure au format Axis xsd_time
       //----------------------------------------------------------------------
       dcl-pr timeToAxis ind ;
           p_time time const ;
           p_xsdtime likeds(xsd_time) ;
       end-pr ;
 